#
# Author: Gustavo Prado Alkmim
# Date: Jun 2011
# Description: This script receive a package and return it's dependencies graph. 
#

package=$1
arch=$2
file=$3
if [ "${4}" == "" ]; then
   work_dir="./"
else
   work_dir="$4"
fi

mkdir -p ${work_dir}
mkdir -p ${work_dir}/cycles_sources
mkdir -p ${work_dir}/cycles_graphs
mkdir -p ${work_dir}/installed_system

initial_dir="${PWD}"

if [ "${package}" == "system" ] || [ "${package}" == "file" ]; then
   if [ "${package}" == "system" ]; then
      sudo apt-cache pkgnames > ./${work_dir}/tmp.tmp
   elif [ "${package}" == "file" ]; then
      cat ${file} > ./${work_dir}/tmp.tmp
   fi
   for pkg_install in `cat ./${work_dir}/tmp.tmp`; do
      echo "--> Analyzing ${pkg_install}-${arch}..."

      echo "/opt/xdeb/allowbinaries/xdeb.py -a ${arch} --prefer-apt --parallel --sequence ${pkg_install} > ./tmp3.tmp"
      /opt/xdeb/allowbinaries/xdeb.py -a ${arch} --prefer-apt --parallel --sequence ${pkg_install} > ./${work_dir}/tmp3.tmp
      exist_cycle=`cat ./${work_dir}/tmp3.tmp | grep "Dependency cycle" | awk -F: '{ print $1 }'`
      is_broken=`cat ./${work_dir}/tmp3.tmp | grep "dependências desencontradas:" | awk  '{ print $6 " " $7 }'`
      no_source=`cat ./${work_dir}/tmp3.tmp | grep "No source package found" | awk '{ print $1 " " $2 " " $3 " " $4}'`
      if [ "${exist_cycle}" == "Dependency cycle" ]; then
         echo "Cycle found. Generating dependencie graph in file ${pkg_install}.eps"
         cat ./tmp3.tmp | grep "Dependency cycle"

         echo "/opt/xdeb/allowbinaries/xdeb.py -a ${arch} --generate-compact-graph --prefer-apt --parallel --sequence ${pkg_install} > ./tmp3.tmp"
         /opt/xdeb/allowbinaries/xdeb.py -a ${arch} --generate-compact-graph --prefer-apt --parallel --sequence ${pkg_install} > ./${work_dir}/tmp3.tmp

         echo "cat ./tmp3.tmp | grep -e \";\" -e \"digraph\" -e \"}\" | grep -v \"arbitrarily\" | sccmap	| \
         gvpr -f /opt/xdeb/allowbinaries/doc/examples/graphutils/make_strict.g  > ./${pkg_install}-${arch}.dot "
#         gvpr -f /opt/xdeb/allowbinaries/doc/examples/graphutils/colour_nodes.g | \
#         gvpr -f /opt/xdeb/allowbinaries/doc/examples/graphutils/colour_cycle.g 
         cat ./${work_dir}/tmp3.tmp | grep -e ";" -e "digraph" -e "}" | grep -v "arbitrarily" | sccmap | \
         gvpr -f /opt/xdeb/allowbinaries/doc/examples/graphutils/make_strict.g  > ./${work_dir}/cycles_graphs/${pkg_install}-${arch}.dot
#         gvpr -f /opt/xdeb/allowbinaries/doc/examples/graphutils/colour_nodes.g | \
#         gvpr -f /opt/xdeb/allowbinaries/doc/examples/graphutils/colour_cycle.g 

         echo "dot -Tps ./${pkg_install}-${arch}.dot 1> ${pkg_install}-${arch}.ps"
         dot -Tps ${work_dir}/cycles_graphs/${pkg_install}-${arch}.dot 1> ${work_dir}/cycles_graphs/${pkg_install}-${arch}.ps

         echo "ps2eps ${pkg_install}-${arch}.ps 1> /dev/null"
         ps2eps -f ${work_dir}/cycles_graphs/${pkg_install}-${arch}.ps 1> /dev/null

         echo "Getting source of packages..."
         cat ${work_dir}/cycles_graphs/${pkg_install}-${arch}.dot | grep -e "\->" | awk '{ print $1 }' | uniq > ${work_dir}/tmp4
         cd ${work_dir}/cycles_sources/
         for pack in `cat ../tmp4`; do
            pack=`echo ${pack} | sed s/\"// | sed s/\"//`
            echo "getting ${pack}/${arch}..."
            echo "apt-get source ${pack}/${arch}" 
#            apt-get source ${pack}/${arch}
#            apt-get source ${pack}/${arch} 1> ../tmp5 2>&1
#            cat ../tmp5
#            for pack2 in `cat ../tmp5 | grep "Impossível" | awk '{ print $8 }' | uniq | sed s/bin-//`; do
#               echo "getting ${pack2}/${arch} instead of ${pack}/${arch}"
#               apt-get source ${pack2}/${arch}
#            done
#            rm ../tmp5
         done
         cd ${initial_dir}

#         rm -f ./${work_dir}/cycles_graphs${pkg_install}-${arch}.ps 1> /dev/null
         rm -f ./${work_dir}/tmp2.tmp 1> /dev/null
         rm -f ./${work_dir}/tmp3.tmp 1> /dev/null
         rm -f ./${work_dir}/tmp4.tmp 1> /dev/null
      elif [ "${is_broken}" == "dependências desencontradas:" ]; then
         cat ./${work_dir}/tmp3.tmp | grep  -e "dependências desencontradas:" -e "Depende"
      elif [ "${no_source}" == "No source package found:" ]; then
         cat ./${work_dir}/tmp3.tmp | grep  -e "No source package found"
      else
         cat ./${work_dir}/tmp3.tmp | grep "Build sequence"
      fi
      echo ""
   done
   rm -f ./${work_dir}/tmp.tmp
else
   echo "--> Analyzing ${package}-${arch}..."

   echo "xdeb -a ${arch} --prefer-apt --parallel --sequence ${package} > ./tmp3.tmp"
   xdeb -a ${arch} --prefer-apt --parallel --sequence ${package} > ./tmp3.tmp

   exist_cycle=`cat tmp3.tmp | grep "Dependency cycle" | awk -F: '{ print $1 }'`
   if [ "${exist_cycle}" == "Dependency cycle" ]; then
      echo "Cycle found. Generating dependencie graph in file ${package}.eps"

      echo "xdeb -a ${arch} --prefer-apt --generate-graph --parallel --sequence ${package} > ./tmp3.tmp"
      xdeb -a ${arch} --prefer-apt --generate-graph --parallel --sequence ${package} > ./tmp3.tmp

      echo "cat tmp3.tmp | grep -e ";" -e "digraph" -e "}" > ./tmp2.tmp"
      cat tmp3.tmp | grep -e ";" -e "digraph" -e "}" > ./tmp2.tmp

      echo "dot -Tps ./tmp2.tmp 1> ${package}-${arch}.ps"
      dot -Tps ./tmp2.tmp 1> ${package}-${arch}.ps 

      echo "ps2eps ${package}-${arch}.ps 1> /dev/null"
      ps2eps ${package}-${arch}.ps 1> /dev/null
      rm -f ${package}-${arch}.ps 1> /dev/null
      rm -f ./tmp2.tmp 1> /dev/null
      rm -f ./tmp3.tmp 1> /dev/null
   else
      cat ./tmp3.tmp | grep "Build sequence"
   fi
fi
rm tmp3.tmp

cd ${inicial_dir}
